﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AMDev.BNET.ClientAPI
{
    [AttributeUsage(AttributeTargets.Field, AllowMultiple=false)]
    public sealed class BNETRegionHostAttribute
        : Attribute
    {
        #region Fields

        private readonly String hostname;
        private readonly String region;
        
        #endregion

        #region Properties

        public String Hostname
        {
            get
            {
                return this.hostname;
            }            
        }

        public String Region
        {
            get
            {
                return this.region;
            }
        }

        #endregion

        #region .ctor

        public BNETRegionHostAttribute(string hostname, string region)
        {
            this.hostname = hostname;
            this.region = region;
        }

        #endregion
    }
}
