﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AMDev.BNET.ClientAPI.WoW
{
    public class GetRealmsStatesEventArgs
        : CommunityAPIClientEventArgs
    {
        #region Properties

        public bool Filtered
        {
            get;
            protected set;
        }

        public WoWRealm[] RealmsStates
        {
            get;
            protected set;
        }

        #endregion

        #region .ctor

        internal GetRealmsStatesEventArgs(WoWRealm[] realmStates)
            : this(realmStates, false, null)
        {
        }

        internal GetRealmsStatesEventArgs(WoWRealm[] realmStates, bool filtered)
            : this(realmStates, filtered, null)
        {
        }

        internal GetRealmsStatesEventArgs(WoWRealm[] realmStates, bool filtered, String restResponse)
            : base(restResponse)
        {
            this.RealmsStates = realmStates;
            this.Filtered = filtered;
        }

        internal GetRealmsStatesEventArgs(bool cancelled, bool error, Exception exc)
            : base(cancelled, error, exc)
        {
        }

        #endregion
    }
}
