﻿using AMDev.BNET.ClientAPI;
using AMDev.BNET.ClientAPI.WoW;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ClientAPI.Test.ConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            WoWAPIClient client = null;
            BNETResponse response = null;
            Task<BNETResponse> realmsTask = null;
            Task<BNETResponse> characterTask = null;
            WoWRealm[] realms = null;
            WoWCharacter character = null;

            client = new WoWAPIClient(RegionsEnumeration.EU);
            realmsTask = client.GetRealmsStatusesAsync();
            characterTask = client.GetCharacterProfileAsync("Doomhammer", "Saberwulf", WoWCharacterProfileCaps.Stats);
            realmsTask.Wait();
            response = realmsTask.Result;
            if (response.HasError)
            {
                Console.WriteLine("An error occured fetching realm list: ");
                Console.WriteLine(response.ErrorValue.ToString());
                Console.WriteLine(response.ErrorMessage);
            }
            else
            {
                realms = response.ResponseData as WoWRealm[];
                Console.WriteLine(realms.ToString());
            }
            characterTask.Wait();
            response = characterTask.Result;
            if (response.HasError)
            {
                Console.WriteLine("An error occured fetching character details: ");
                Console.WriteLine();
                Console.WriteLine(response.ErrorValue.ToString());
                Console.WriteLine();
                Console.WriteLine(response.ErrorMessage);
            }
            else
            {
                character = response.ResponseData as WoWCharacter;
                Console.WriteLine(character.ToString());
            }
            Console.WriteLine("Press key to continue...");
            Console.ReadKey();
        }
    }
}

